package pwc.taxtech.atms.vat.dao;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.session.RowBounds;
import pwc.taxtech.atms.MyVatMapper;
import pwc.taxtech.atms.vat.dpo.MergerManaualCellData;
import pwc.taxtech.atms.vat.entity.PCTEntity;
import pwc.taxtech.atms.vat.entity.PeriodCellData;
import pwc.taxtech.atms.vat.entity.PeriodCellDataExample;

import java.util.List;
import java.util.Set;

@Mapper
public interface PeriodCellDataMapper extends MyVatMapper {
    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.PERIOD_CELL_DATA
     *
     * @mbg.generated
     */
    long countByExample(PeriodCellDataExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.PERIOD_CELL_DATA
     *
     * @mbg.generated
     */
    int deleteByExample(PeriodCellDataExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.PERIOD_CELL_DATA
     *
     * @mbg.generated
     */
    int deleteByPrimaryKey(Long id);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.PERIOD_CELL_DATA
     *
     * @mbg.generated
     */
    int insert(PeriodCellData record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.PERIOD_CELL_DATA
     *
     * @mbg.generated
     */
    int insertSelective(PeriodCellData record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.PERIOD_CELL_DATA
     *
     * @mbg.generated
     */
    List<PeriodCellData> selectByExampleWithRowbounds(PeriodCellDataExample example, RowBounds rowBounds);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.PERIOD_CELL_DATA
     *
     * @mbg.generated
     */
    List<PeriodCellData> selectByExample(PeriodCellDataExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.PERIOD_CELL_DATA
     *
     * @mbg.generated
     */
    PeriodCellData selectByPrimaryKey(Long id);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.PERIOD_CELL_DATA
     *
     * @mbg.generated
     */
    int updateByExampleSelective(@Param("record") PeriodCellData record, @Param("example") PeriodCellDataExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.PERIOD_CELL_DATA
     *
     * @mbg.generated
     */
    int updateByExample(@Param("record") PeriodCellData record, @Param("example") PeriodCellDataExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.PERIOD_CELL_DATA
     *
     * @mbg.generated
     */
    int updateByPrimaryKeySelective(PeriodCellData record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.PERIOD_CELL_DATA
     *
     * @mbg.generated
     */
    int updateByPrimaryKey(PeriodCellData record);

    int batchInsert2(List<PeriodCellData> list);

    int batchInsert(List<PeriodCellData> list);

    @Select("<script>" +
            "SELECT  " +
            "  count( pcds.DATA_SOURCE_ID ) AS dsCount,  " +
            "  pcd.ID as cellId,  " +
            "  pcd.DATA as data,  " +
            "  pcd.FORMULA_EXP as formulaExp,  " +
            "  pcd.CELL_TEMPLATE_ID as cellTemplateId,  " +
            "  pcd.PERIOD as period,  " +
            "  temp.AMOUNT as amount   " +
            "FROM  " +
            "  PERIOD_CELL_DATA pcd  " +
            "  JOIN PERIOD_CELL_DATA_SOURCE pcds ON pcd.ID = pcds.CELL_DATA_ID  " +
            "  LEFT JOIN (  " +
            "  SELECT  " +
            "    pcd.ID,  " +
            "    pds.TYPE,  " +
            "    pds.AMOUNT,  " +
            "    pds.PERIOD,  " +
            "    pds.PROJECT_ID  " +
            "  FROM  " +
            "    PERIOD_CELL_DATA pcd  " +
            "    JOIN PERIOD_CELL_DATA_SOURCE pcds ON pcd.ID = pcds.CELL_DATA_ID  " +
            "    JOIN PERIOD_DATA_SOURCE pds ON pcds.DATA_SOURCE_ID = pds.ID   " +
            "  WHERE  " +
            "    pcd.PROJECT_ID = #{projectId}   " +
            "    AND pds.TYPE = 10   " +
            "  ) temp ON pcd.ID = temp.ID AND pcd.PROJECT_ID = temp.PROJECT_ID and pcd.PERIOD = temp.period  " +
            "WHERE  " +
            "  pcd.PERIOD = 10   " +
            "  AND pcd.PROJECT_ID = #{projectId}   AND " +
            "  <foreach item=\"item\" index=\"index\" collection=\"list\"" +
            "      open=\"(\" separator=\"OR\" close=\")\">" +
            "        ( pcd.PERIOD=#{item.period} AND pcd.CELL_TEMPLATE_ID=#{item.cellTemplateId} )" +
            "  </foreach>" +
            "GROUP BY  " +
            "  pcd.ID,  " +
            "  pcd.DATA,  " +
            "  pcd.FORMULA_EXP,  " +
            "  pcd.CELL_TEMPLATE_ID,  " +
            "  pcd.PERIOD,  " +
            "  temp.AMOUNT" +
            "</script>")
    List<PCTEntity> queryByPCTs(@Param("list") Set<PCTEntity> parameter, @Param("projectId") String projectId);
}