package pwc.taxtech.atms.vat.entity;

public class PCTEntity {
    Integer period;
    Long cellTemplateId;
    String data;
    String formulaExp;
    Long cellId;
    String amount;
    Integer dsCount;

    public PCTEntity() {
    }

    public PCTEntity(String pctStr) {
        String[] pct = pctStr.split(":");
        this.period = Integer.parseInt(pct[0]);
        this.cellTemplateId = Long.parseLong(pct[1]);
    }

    @Override
    public int hashCode() {
        return (period + "" + cellTemplateId).hashCode();
    }

    @Override
    public boolean equals(Object obj) {
        PCTEntity target = (PCTEntity) obj;
        return period.intValue() == target.period.intValue()
                && cellTemplateId.longValue() == target.cellTemplateId.longValue();
    }

    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    public Long getCellTemplateId() {
        return cellTemplateId;
    }

    public void setCellTemplateId(Long cellTemplateId) {
        this.cellTemplateId = cellTemplateId;
    }

    public String getData() {
        return data;
    }

    public void setData(String data) {
        this.data = data;
    }

    public String getFormulaExp() {
        return formulaExp;
    }

    public void setFormulaExp(String formulaExp) {
        this.formulaExp = formulaExp;
    }

    public Long getCellId() {
        return cellId;
    }

    public void setCellId(Long cellId) {
        this.cellId = cellId;
    }

    public String getAmount() {
        return amount;
    }

    public void setAmount(String amount) {
        this.amount = amount;
    }

    public Integer getDsCount() {
        return dsCount;
    }

    public void setDsCount(Integer dsCount) {
        this.dsCount = dsCount;
    }
}
